Bug 1900235 - ansible fails to build with Python 3.10: ansible-test units: error: argument --python: invalid choice: '3.10'
Summary: ansible fails to build with Python 3.10: ansible-test units: error: argument ...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: ansible
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Kevin Fenzi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-21 16:40 UTC by Miro Hrončok
Modified: 2021-01-05 12:42 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-01-05 12:42:30 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github ansible ansible pull 72852 0 None open Add Python 3.10 to ansible-test 2021-01-05 12:41:18 UTC

Description Miro Hrončok 2020-11-21 16:40:57 UTC
ansible fails to build with Python 3.10.0a2:

bin/ansible-test units -v --python 3.10 
usage: ansible-test units [-h] [-e] [-v] [--color [COLOR]] [--debug]
                          [--truncate COLUMNS] [--redact] [--no-redact]
                          [--include TARGET] [--exclude TARGET]
                          [--require TARGET] [--coverage]
                          [--coverage-label COVERAGE_LABEL] [--coverage-check]
                          [--base-branch BASE_BRANCH] [--changed]
                          [--untracked] [--ignore-committed] [--ignore-staged]
                          [--ignore-unstaged] [--requirements]
                          [--python-interpreter PATH] [--local] [--venv]
                          [--tox] [--tox-sitepackages] [--docker [IMAGE]]
                          [--remote PLATFORM] [--remote-stage STAGE]
                          [--remote-provider PROVIDER]
                          [--remote-endpoint ENDPOINT]
                          [--remote-aws-region REGION]
                          [--remote-terminate WHEN] [--python VERSION]
                          [--collect-only] [--num-workers NUM_WORKERS]
                          [--docker-no-pull] [--docker-keep-git]
                          [--docker-seccomp SC]
                          [TARGET ...]
ansible-test units: error: argument --python: invalid choice: '3.10' (choose from '2.6', '2.7', '3.5', '3.6', '3.7', '3.8', '3.9', 'default')


Looks like upstream is hardcoding a list of Python versions :/


For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01783117-ansible/

For all our attempts to build ansible with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/ansible/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.


Marking severity as high, because ansible is important.

Comment 1 Tomáš Hrnčiar 2020-12-04 09:59:56 UTC
Upstream has hardcoded Python versions. I have opened PR to add 3.10.

https://github.com/ansible/ansible/pull/72852


Note You need to log in before you can comment on or make changes to this bug.